Summary: Pilot Link - USR Pilot to Unix transfer utilities
Name: pilot-link
Version: 0.8.13
Release: 1
Source:  ftp://ryeham.ee.ryerson.ca/pub/PalmOS/pilot-link.0.8.13.tar.gz
Patch0: pilot-link-perl-install.patch
Patch1: pilot-link.perl.patch
Patch2: pilotlink-PERL5.patch
Patch3: pilot-link-ppc-delay.patch
Copyright: GPL
Group: Utilities/System
BuildRoot: /home/warner/stuff/redhat/buildroot/pilot-link
# note to builders: the BuildRoot interacts badly with the internally-generated
# shared libraries. It helps to have this package already installed when
# building this package, since then the 'ldd' commands run by RPM's automatic
# find-requires tool will succeed (otherwise it would fail because of the
# missing libpisock.so.3). I don't think there are any shared-library
# dependencies that get missed because of this, but just in case, I installed
# the package and then rebuilt it.

%description
This suite of tools allows you to upload and download programs
and data files between a *nix machine and the USR Pilot.  It has
a few extra utils that will allow for things like syncing the
Pilot's calendar app with Ical.  Note that you might still need
to consult the sources for pilot-link if you would like the
Python, Tcl, or Perl bindings.

%package devel
Requires: pilot-link
Summary: Pilot Development Headers
Group: Development/Building

%description devel
This package contains the development headers that are used
to build the pilot-link package.  It also includes the static
libraries necessary to build static pilot apps.

%changelog

* Sun Jun 21 1998 Brian Warner <warner@lothar.com>

- added patch for ppc-linux.. pilot-xfer get stuck after xfer w/o a small delay
- set LDFLAGS=-s to strip binaries.. much much smaller
- used a BuildRoot

* Tue May 19 1998 Michael Maher <mike@redhat.com>

- updated rpm

* Thu Jan 29 1998 Otto Hammersmith <otto@redhat.com>

- added changelog
- updated to 0.8.9
- removed explicit requires for /usr/bin/perl

%prep 
%setup -n pilot-link.%{PACKAGE_VERSION}
%patch0 -p1 -b .install
%patch1 -p1 -b .perl
#%patch2 -p1 -b .more-perl
%ifarch ppc
%patch3 -p1 -b .ppc
%endif

%build
LDFLAGS=-s ./configure --prefix=/usr
make

%install
make install prefix=$RPM_BUILD_ROOT/usr
#make Perl5  prefix=/usr
#cd Perl5
#make install LD_RUN_PATH=/usr

%post
/sbin/ldconfig

%postun
/sbin/ldconfig

%clean
rm -rf $RPM_BUILD_ROOT

%files
%attr(-, root, root) %doc COPYING ChangeLog README

%attr(-, root, root) /usr/lib/libpisock.so.3.0.1
%attr(-, root, root) /usr/lib/libpisock.so.3
%attr(-, root, root) /usr/lib/libpisock.so

#/usr/lib/perl5/site_perl/i386-linux/auto/PDA/Pilot/Pilot.so
#/usr/lib/perl5/site_perl/i386-linux/auto/PDA/Pilot/Pilot.bs
#/usr/lib/perl5/site_perl/PDA/dump.pl
#/usr/lib/perl5/site_perl/PDA/Pilot.pm
#/usr/lib/perl5/site_perl/auto/PDA/Pilot/autosplit.ix
#/usr/lib/perl5/site_perl/i386-linux/auto/PDA/Pilot/.packlist

%attr(-, root, root) /usr/bin/addresses
%attr(-, root, root) /usr/bin/ccexample
%attr(-, root, root) /usr/bin/debugsh
%attr(-, root, root) /usr/bin/dlpsh
%attr(-, root, root) /usr/bin/getrom
%attr(-, root, root) /usr/bin/iambicexample
%attr(-, root, root) /usr/bin/ietf2datebook
%attr(-, root, root) /usr/bin/install-datebook
%attr(-, root, root) /usr/bin/install-memo
%attr(-, root, root) /usr/bin/install-todos
%attr(-, root, root) /usr/bin/install-user
%attr(-, root, root) /usr/bin/memos
%attr(-, root, root) /usr/bin/pi-csd
%attr(-, root, root) /usr/bin/pi-getram
%attr(-, root, root) /usr/bin/pi-getrom
%attr(-, root, root) /usr/bin/pi-nredir
%attr(-, root, root) /usr/bin/pi-port
%attr(-, root, root) /usr/bin/pilot-addresses
%attr(-, root, root) /usr/bin/pilot-clip
%attr(-, root, root) /usr/bin/pilot-debug
%attr(-, root, root) /usr/bin/pilot-dedupe
%attr(-, root, root) /usr/bin/pilot-file
%attr(-, root, root) /usr/bin/pilot-mail
%attr(-, root, root) /usr/bin/pilot-schlep
%attr(-, root, root) /usr/bin/pilot-undelete
%attr(-, root, root) /usr/bin/pilot-xfer
%attr(-, root, root) /usr/bin/read-expenses
%attr(-, root, root) /usr/bin/read-ical
%attr(-, root, root) /usr/bin/read-todos
%attr(-, root, root) /usr/bin/reminders
%attr(-, root, root) /usr/bin/sync-plan

%attr(-, root, root) /usr/man/man1/dlpsh.1
%attr(-, root, root) /usr/man/man1/ietf2datebook.1
%attr(-, root, root) /usr/man/man1/install-datebook.1
%attr(-, root, root) /usr/man/man1/install-memo.1
%attr(-, root, root) /usr/man/man1/install-user.1
%attr(-, root, root) /usr/man/man1/pilot-xfer.1
%attr(-, root, root) /usr/man/man1/read-ical.1
%attr(-, root, root) /usr/man/man7/pilot-link.7

%attr(-, root, root) /usr/lib/pix/b1.gif
%attr(-, root, root) /usr/lib/pix/b2.gif
%attr(-, root, root) /usr/lib/pix/b3.gif
%attr(-, root, root) /usr/lib/pix/b4.gif
%attr(-, root, root) /usr/lib/pix/b5.gif
%attr(-, root, root) /usr/lib/pix/b6.gif
%attr(-, root, root) /usr/lib/pix/b7.gif
%attr(-, root, root) /usr/lib/pix/case.gif
%attr(-, root, root) /usr/lib/pix/case.xbm
%attr(-, root, root) /usr/lib/pix/casemask.xbm

%files devel
%attr(-, root, root) /usr/lib/libpisock.la
%attr(-, root, root) /usr/lib/libpisock.a
%attr(-, root, root) /usr/lib/libpicc.a

%attr(-, root, root) /usr/include/pi-address.h
%attr(-, root, root) /usr/include/pi-address.hxx
%attr(-, root, root) /usr/include/pi-appinfo.h
%attr(-, root, root) /usr/include/pi-appinfo.hxx
%attr(-, root, root) /usr/include/pi-args.h
%attr(-, root, root) /usr/include/pi-cmp.h
%attr(-, root, root) /usr/include/pi-config.h
%attr(-, root, root) /usr/include/pi-datebook.h
%attr(-, root, root) /usr/include/pi-datebook.hxx
%attr(-, root, root) /usr/include/pi-dlp.h
%attr(-, root, root) /usr/include/pi-expense.h
%attr(-, root, root) /usr/include/pi-file.h
%attr(-, root, root) /usr/include/pi-iambicExpense.h
%attr(-, root, root) /usr/include/pi-iambicExpense.hxx
%attr(-, root, root) /usr/include/pi-inet.h
%attr(-, root, root) /usr/include/pi-inetserial.h
%attr(-, root, root) /usr/include/pi-macros.h
%attr(-, root, root) /usr/include/pi-mail.h
%attr(-, root, root) /usr/include/pi-memo.h
%attr(-, root, root) /usr/include/pi-memo.hxx
%attr(-, root, root) /usr/include/pi-padp.h
%attr(-, root, root) /usr/include/pi-serial.h
%attr(-, root, root) /usr/include/pi-slp.h
%attr(-, root, root) /usr/include/pi-socket.h
%attr(-, root, root) /usr/include/pi-source.h
%attr(-, root, root) /usr/include/pi-sync.h
%attr(-, root, root) /usr/include/pi-syspkt.h
%attr(-, root, root) /usr/include/pi-todo.h
%attr(-, root, root) /usr/include/pi-todo.hxx
