
# Notes to rebuilders:
# you must have pilrc installed as /usr/bin/pilrc to compile this package
# (prc-tools-0.5.0/{gdbpanel,example} requires it)
# You shouldn't have any PalmOS include files installed when you compile
# this package, because if gcc sees them during compilation it will make fixed
# copies and install those in addition to the unfixed copies installed by
# prc-tools. (unfixed go in /usr/m68k-palmos-coff/include/PalmOS[123],
# fixed probably go in /usr/lib/gcc-lib/m68k-palmos-coff/2.7.2.2etc/include).
# having the includes fixed doesn't seem too important, and results in the
# files being installed twice, so it seems reasonable to avoid it.
#
# I'd like to figure out how to strip the binaries after installing, but
# I don't know of a convenient way to do so.
#
# I ignore a lot of the prc-tools Makefile to make it build before installing
# any of the compiler tools. If this were several separate packages, and
# binutils had to be installed before building gcc, and gcc before prc-tools,
# then we wouldn't have so many bizarre tricks.
#
# this package can be built by a non-root user and does not install anything
# into the system (only into the BuildRoot). Building it with -O0 for testing
# on my ppc system (no gdb) takes 10 minutes. -O2 takes 16.

Summary: Development Suite for the Pilot (gcc, binutils, gdb)
Name: prc-tools
Version: 0.5.0
Release: 2
Copyright: GPL
Group: Development/Building
Source0: ftp://RyeHam.EE.Ryerson.Ca/pub/PalmOS/prc-tools.0.5.0.tar.gz
Source1: ftp://prep.ai.mit.edu/pub/gcc-2.7.2.2.tar.gz
Source2: ftp://prep.ai.mit.edu/pub/gdb-4.16.tar.gz
Source3: ftp://prep.ai.mit.edu/pub/binutils-2.7.tar.gz
# The includes were sucked out of the winsdk30_a9.zip from www.palmpilot.com
Source4: PalmOS3-includes.tar.gz
Source5: prc-tools-callbacks.txt
Patch0: prc-tools-make.patch
Patch1: prc-tools-ppc-gcc.diff
URL: ftp://RyeHam.EE.Ryerson.Ca/pub/PalmOS/
BuildRoot: /home/warner/stuff/redhat/buildroot/prc-tools-0.5.0

%changelog

* Sun Jun 21 1998 <warner@lothar.com>

- added linux-ppc support (not for gdb, sorry)
- remove -g from CFLAGS to make smaller binaries
- don't install non-palmos-specific headers or man pages (bfd.h, configure.1)
  binutils: don't install from the bfd or libiberty directories
  gcc: break up 'install' target, skipping install-man and install-info,
       then manually copy m68k-palmos-coff-gcc.1 into place
- hack build process to use a BuildRoot instead of installing binutils
  just enough to appease gcc while building libgcc.a
- install gdbpanel.prc in docs directory
- install mathf.h in the right place

* Sun Jun 14 1998 <djb@redhat.com>

- first time packaging
- note that PalmOS2 is the default set of include files.  To change that
  to PalmOS1 or PalmOS3, change the /usr/m68k-palmos-coff/include/PalmOS
  symlink to point to the right place.
- this package requires the pilrc package to be installed to build
  properly (available as a separate RPM)

%description
This is a complete build environment for the 3Com PalmPilot.  It
includes gcc and associated linkers as well as gdb for debugging.
This is based on binutils-2.7, gcc-2.7.2.2, and gdb-4.16 (gdb not available
on linux-ppc, sorry).

Note that PalmOS2 is the default set of include files.  To change that
to PalmOS1 or PalmOS3, change the /usr/m68k-palmos-coff/include/PalmOS
symlink to point to the right place.

Also note that this version of gcc has a bug that affects callback functions.
For workaround information, see /usr/doc/prc-tools-0.5.0-2/README.callbacks

%prep
%ifarch i386
$RPM_HOSTSPEC=--host=i386-unknown-linux
%endif
# unpack the prc-tools tarfile
%setup -q -c
cd prc-tools-0.5.0
%patch -p1 -b .djb
tar xfz $RPM_SOURCE_DIR/PalmOS3-includes.tar.gz
mv -f Incs PalmOS3
# unpack the binutils, gcc, and gdb tarfiles
make GNUARCH=$RPM_SOURCE_DIR gnuuntar
# apply the palmos patches
make GNUARCH=$RPM_SOURCE_DIR patch
# apply the PowerPC gcc patch if necessary
%ifarch ppc
cd ../gcc-2.7.2.2
patch -p1 < $RPM_SOURCE_DIR/prc-tools-ppc-gcc.diff
%endif

# now configure them all
cd ../binutils-2.7
./configure $RPM_HOSTSPEC --prefix=/usr --target=m68k-palmos-coff
cd ../gcc-2.7.2.2
./configure $RPM_HOSTSPEC --prefix=/usr --target=m68k-palmos-coff
%ifnarch ppc
cd ../gdb-4.16
./configure $RPM_HOSTSPEC --prefix=/usr --target=m68k-palmos-coff
%endif
cd ..


%build
RPM_MYTOPDIR=$RPM_BUILD_DIR/$RPM_PACKAGE_NAME-$RPM_PACKAGE_VERSION
# building. the prc-tools Makefile has entries for all of this. We ignore them
# all. In fact, we ignore most of the prc-tools top-level Makefile.
# start with binutils
cd binutils-2.7
make CFLAGS="$RPM_OPT_FLAGS"
#make info

# now gcc. must play some games to let libgcc.a get built using the just-built
# but not-yet-installed binutils. need as,ld,ar,ranlib
cd ../gcc-2.7.2.2
mkdir m68k-palmos-coff
mkdir m68k-palmos-coff/2.7.2.2-kgpd-071097
cd m68k-palmos-coff/2.7.2.2-kgpd-071097
ln -s ../../../binutils-2.7/gas/as.new as
ln -s ../../../binutils-2.7/ld/ld.new ld
cd ../..
# now build gcc with a special flag that will point ar and ranlib correctly
make CFLAGS="$RPM_OPT_FLAGS" LANGUAGES=c TARGET_TOOLPREFIX=$RPM_MYTOPDIR/binutils-2.7/binutils/
#make LANGUAGES=c info

# gdb-4.16 can't do the cross from ppc to anything else: ppc as the host is 
# bound too tightly to ppc as a target. So don't build gdb on ppc
%ifnarch ppc
cd ../gdb-4.16
make CFLAGS="$RPM_OPT_FLAGS"
#make info
%endif

cd ..
ln -s binutils-2.7/binutils/ar m68k-palmos-coff-ar
ln -s binutils-2.7/binutils/ranlib m68k-palmos-coff-ranlib
ln -s binutils-2.7/binutils/nm.new m68k-palmos-coff-nm

cd prc-tools-0.5.0
# prc-tools. We need TOOLDIR to point to where 'nm' will live, and probably
# need it to be there so we can use 'exportlist' during the prc-tools build.
# we also need to get at the cross bfd.a library, to build obj-res.

# hmm, we really need all the tools to be pre-installed. How about doing a
# 'make stage1' in gcc, which will assemble all the bits and pieces gcc
# needs in one subdirectory, then making symlinks from within there to
# the right binutils directories. Then set CC right for the prc-tools build
# (like CC="$RPM_MYTOP/gcc-2.7.2.2/stage1/gcc -B..../stage1"). Hmm.
CC_TARGET="$RPM_MYTOPDIR/gcc-2.7.2.2/xgcc -B$RPM_MYTOPDIR/gcc-2.7.2.2/"

# build exportlist, obj-res, build-prc first. This will create a temporary
# version of exportlist that refers to the TOOLDIR version of nm. Once we've
# build the libraries, delete it and build it again with the right TOOLDIR
make exportlist TOOLDIR=$RPM_MYTOPDIR
make obj-res build-prc LBFD="$RPM_MYTOPDIR/binutils-2.7/bfd/libbfd.a $RPM_MYTOPDIR/binutils-2.7/libiberty/libiberty.a"
# build libc, libm, libGLib with CC_TARGET,AR_TARGET,RANLIB_TARGET
make -C libmf.0.1.2 CC="$CC_TARGET" TOOLDIR=$RPM_MYTOPDIR
make -C libglib.0.1.0 CC="$CC_TARGET" TOOLDIR=$RPM_MYTOPDIR
# libc.a requires libGLib.a to be built first, scrt0.o in particular
make -C libc.0.1.2 CC="$CC_TARGET" TOOLDIR=$RPM_MYTOPDIR LIBGLIBDIR=libglib.0.1.0

# now build whatever's left
make txt2bitm
make -C gdbpanel CC="$CC_TARGET" LIBCDIR=libc.0.1.2 LIBGLIBDIR=libglib.0.1.0
make -C example CC="$CC_TARGET" LIBCDIR=libc.0.1.2 LIBGLIBDIR=libglib.0.1.0
# now build the real exportlist (that will use the installed cross-nm)
rm -f exportlist
make exportlist TOOLDIR=/usr/bin

%install

# installation. We install into the build root, choosing weird targets to
# avoid installing anything that isn't target specific (like bfd header files,
# readline libraries, etc). Such files would both overlap with native tools
# and are probably much older versions than their native counterparts.

# if we're using a build root, create the directory structure now
mkdir -p $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/usr/bin $RPM_BUILD_ROOT/usr/lib $RPM_BUILD_ROOT/usr/m68k-palmos-coff/lib $RPM_BUILD_ROOT/usr/m68k-palmos-coff/include $RPM_BUILD_ROOT/usr/m68k-palmos-coff/bin $RPM_BUILD_ROOT/usr/man/man1

# install binutils
cd binutils-2.7
make install-binutils install-gas install-ld prefix=$RPM_BUILD_ROOT/usr

# install gcc
cd ../gcc-2.7.2.2
make LANGUAGES=c install-common install-headers install-libgcc install-libobjc lang.install-normal install-driver prefix=$RPM_BUILD_ROOT/usr
cp gcc.1 $RPM_BUILD_ROOT/usr/man/man1/m68k-palmos-coff-gcc.1

# install gdb
%ifnarch ppc
cd ../gdb-4.16
make install-dirs install-gdb prefix=$RPM_BUILD_ROOT/usr
%endif

# now for the prc-tools themselves
cd ../prc-tools-0.5.0
# this 'install' target also installs an out-of-date manpage for pilrc,
# but that's arguably better than nothing (pilrc-2.0a comes with an HTML page)
make INSTPREFIX=$RPM_BUILD_ROOT/usr install
cp -ar COPYING README README.reloc README.shared gdbpanel/gdbpanel.prc example/pilrctst.prc ..

cd ..
cp $RPM_SOURCE_DIR/prc-tools-callbacks.txt README.callbacks

%clean
rm -rf $RPM_BUILD_ROOT

%files
%attr(-, root, root) %doc COPYING README README.reloc README.shared README.callbacks gdbpanel.prc pilrctst.prc

%attr(-, root, root) /usr/man/man1/m68k-palmos-coff-ar.1
%attr(-, root, root) /usr/man/man1/m68k-palmos-coff-as.1
%attr(-, root, root) /usr/man/man1/m68k-palmos-coff-c++filt.1
%attr(-, root, root) /usr/man/man1/m68k-palmos-coff-gcc.1
%ifnarch ppc
%attr(-, root, root) /usr/man/man1/m68k-palmos-coff-gdb.1
%endif
%attr(-, root, root) /usr/man/man1/m68k-palmos-coff-ld.1
%attr(-, root, root) /usr/man/man1/m68k-palmos-coff-nlmconv.1
%attr(-, root, root) /usr/man/man1/m68k-palmos-coff-nm.1
%attr(-, root, root) /usr/man/man1/m68k-palmos-coff-objcopy.1
%attr(-, root, root) /usr/man/man1/m68k-palmos-coff-objdump.1
%attr(-, root, root) /usr/man/man1/m68k-palmos-coff-ranlib.1
%attr(-, root, root) /usr/man/man1/m68k-palmos-coff-size.1
%attr(-, root, root) /usr/man/man1/m68k-palmos-coff-strings.1
%attr(-, root, root) /usr/man/man1/m68k-palmos-coff-strip.1

%attr(-, root, root) /usr/man/man1/build-prc.1
%attr(-, root, root) /usr/man/man1/obj-res.1
%attr(-, root, root) /usr/man/man1/pilrc.1
%attr(-, root, root) /usr/man/man1/txt2bitm.1

%attr(-, root, root) /usr/bin/m68k-palmos-coff-ar
%attr(-, root, root) /usr/bin/m68k-palmos-coff-as
%attr(-, root, root) /usr/bin/m68k-palmos-coff-c++filt
%attr(-, root, root) /usr/bin/m68k-palmos-coff-gasp
%attr(-, root, root) /usr/bin/m68k-palmos-coff-gcc
%ifnarch ppc
%attr(-, root, root) /usr/bin/m68k-palmos-coff-gdb
%endif
%attr(-, root, root) /usr/bin/m68k-palmos-coff-objcopy
%attr(-, root, root) /usr/bin/m68k-palmos-coff-objdump
%attr(-, root, root) /usr/bin/m68k-palmos-coff-ld
%attr(-, root, root) /usr/bin/m68k-palmos-coff-nm
%attr(-, root, root) /usr/bin/m68k-palmos-coff-ranlib
%attr(-, root, root) /usr/bin/m68k-palmos-coff-size
%attr(-, root, root) /usr/bin/m68k-palmos-coff-strings
%attr(-, root, root) /usr/bin/m68k-palmos-coff-strip

%attr(-, root, root) /usr/bin/build-prc
%attr(-, root, root) /usr/bin/m68k-palmos-coff-obj-res
%attr(-, root, root) /usr/bin/m68k-palmos-coff-exportlist
%attr(-, root, root) /usr/bin/m68k-palmos-coff-stubgen
%attr(-, root, root) /usr/bin/txt2bitm

%attr(-, root, root) /usr/lib/gcc-lib/m68k-palmos-coff

# this also fixes up the PalmOS3 tarfile to have files owned by root, not djb
%attr(-, root, root) /usr/m68k-palmos-coff
